

nea <-function (ags, fgs, fgslib = NULL, network, pnet = NULL, nperm = 50,stat = "F", seed = NULL) 
{
	FGS =fgs
	if (is.null(fgslib)) fgslib <- "nolibrary"
	if (fgslib!="reactome.db" && fgslib!="GO.db"&&  fgslib!="KEGG.db") {
		#if (is.null(fgslib)) {
		if (is.character(fgs)) {
			fgs.type = 5
			fgs.list <- list()
			fgs.list[[1]] <- fgs
			fgs <- fgs.list
		}
		if (!is.list(fgs) && length(fgs) == 1) {
			require(fgslib, character.only = TRUE) || stop("need data package:",fgslib)
			require("GOstats", character.only = TRUE) || stop("need data package:","GOstats")
		}
		if (!is.null(fgslib) && is.character(fgslib)) {
			fgslib <- substr(fgslib, 1, nchar(fgslib) - 3)
		}
	}
	
	if (any(duplicated(ags))) 
		print("Duplicated in AGS: This procedure makes the input(gene symbols) unique")
	ags <- unique(toupper(ags))
	if (is.list(fgs)) {
		fgs <- lapply(fgs, toupper)
		fgs <- lapply(fgs, unique)
	}
	if (is.character(network)) {
		network <- toupper(network)
	}
	if (is.list(network)) {
		network <- lapply(network, toupper)
	}
	
	if (fgslib=="KEGG.db"){
		require(KEGG.db)
		require(org.Hs.eg.db)
		mapped.genes<-AnnotationDbi::as.list(KEGGPATHID2EXTID)  
		fgs<-list()
		for (i in 1:length(mapped.genes)){
			mg.name<-mapped.genes[[i]]
			fgs[[i]] <- unique(unlist(AnnotationDbi::mget(c(mg.name), org.Hs.egSYMBOL, ifnotfound=NA)))  
		}	
		names(fgs)<-names(mapped.genes)
		fgs<-fgs[-which(lapply(fgs,length)==1)]
	}
	if (fgslib=="reactome.db"){
		require(reactome.db)
		require(org.Hs.eg.db)
		mapped.genes<-AnnotationDbi::as.list(reactomePATHID2EXTID)  
		fgs<-list()
		for (i in 1:length(mapped.genes)){
			mg.name<-mapped.genes[[i]]
			fgs[[i]] <- unique(unlist(AnnotationDbi::mget(c(mg.name), org.Hs.egSYMBOL, ifnotfound=NA)))  
		}	
		names(fgs)<-names(mapped.genes)
		fgs<-fgs[-which(lapply(fgs,length)==1)]
	}
	if (fgslib=="GO.db"){
		require(org.Hs.eg.db)
		require(GO.db)
		xx<-AnnotationDbi::as.list(org.Hs.egGO2ALLEGS)
		fgs<-list()
		for (i in 1:length(xx)){
			fgs[[i]] <- unique(names(xx[[i]])) 
		}
		names(fgs)<-names(xx)	
		fgs<-fgs[-which(lapply(fgs,length)==1)]
	}
	if (is.null(pnet)) {
		doperm <- "yes"
	}
	if (is.list(pnet)) {
		doperm <- "no"
		nperm <- length(pnet)
	}
	if (is.character(fgs) && fgs == "MF") {
		fgs.type = 1
	}
	if (is.character(fgs) && fgs == "BP") {
		fgs.type = 2
	}
	if (is.character(fgs) && fgs == "CC") {
		fgs.type = 3
	}
	if (is.character(fgs) && fgs == "KEGG") {
		fgs.type = 4
		fgs.probe <- as.list(get(paste(fgslib, "PATH2PROBE", sep = "")))
	}
	if (is.list(fgs)) {
		fgs.type = 5
		fgs.list <- fgs
	}
	if (fgs.type < 4) {
		fgs.probe <- as.list(get(paste(fgslib, "GO2REACTOMEID", sep = "")))
		fgsname <- names(fgs.probe)
		ont <- Ontology(fgsname)
	}
	if (fgs.type < 5) {
		mapped.genes<-AnnotationDbi::as.list(reactomeGO2REACTOMEID)  
		fgs.list<-list()
		for (i in 1:length(mapped.genes)){
			mg.name<-mapped.genes[[i]]
			fgs.list[[i]] <- unique(unlist(AnnotationDbi::mget(c(mg.name), org.Hs.egSYMBOL, ifnotfound=NA)))  
		}	
		names(fgs.list)<-names(mapped.genes)
		fgs.list<-fgs.list[-which(lapply(fgs.list,length)==1)]
	}
	if (is.character(network)) {
		margin <- countcon(network)
		genes <- margin$genes
	}
	if (is.list(network)) {
		anet <- list2arr0(network)
		margin <- countcon(anet)
		genes <- margin$genes
	}
	if (is.character(network) && stat == "F") {
		netlist2 <- arr2list(network, gsym = genes)
		nlink <- linknum.arr(ags, fgs = fgs.list, netlist2, gnum = TRUE, 
				gsym = genes)
	}
	if (is.list(network) && stat == "F") {
		nlink <- linknum.list(ags, fgs = fgs.list, network, gnum = TRUE, 
				gsym = genes)
	}
	if (is.character(network) && stat == "M") {
		netlist2 <- arr2list(network, gsym = genes)
		nlink <- linknum.arr.csum(ags, fgs = fgs.list, netlist2, 
				gnum = TRUE, gsym = genes)
	}
	if (is.list(network) && stat == "M") {
		nlink <- linknum.list.csum(ags, fgs = fgs.list, network, 
				gnum = TRUE, gsym = genes)
	}
	if (is.null(seed)) {
		set.seed(Sys.time())
	}
	if (!is.null(seed)) {
		set.seed(seed)
	}
	if (stat == "F") {
		res.nlink <- matrix(0, length(fgs.list), nperm)
	}
	if (stat == "M") {
		res.nlink <- vector("list", nperm)
	}
	
	
	### new commands ###
	
	pnetout <- list ()
	geneinfgs <- list()
	numgene <- NULL
	for (i in 1:length(fgs.list) ) {
		geneinfgs [[i]] <- ags[which(ags %in% fgs.list[[i]])]
		numgene[i] <- length(geneinfgs [[i]])
	}
	
	ngenefgs <- sapply(fgs.list, length)
	
	#### 
	
	
	for (i in 1:nperm) {
		if (doperm == "yes" && stat == "F") {
			perm.ncon <- netperm(margin$ncon)
			pos1 <- perm.ncon$pos1
			res.nlink[, i] <- linknum.list(ags, fgs = fgs.list, 
					netlist = pos1, gnum = TRUE, gsym = genes)
			##
			pnetout[[i]] <-   pos1     
			
		}
		
		if (doperm == "no" && stat == "F") {
			res.nlink[, i] <- linknum.list(ags, fgs = fgs.list, 
					netlist = pnet[[i]], gnum = TRUE, gsym = genes)
			##
		}
		
		if (doperm == "yes" && stat == "M") {
			perm.ncon <- netperm(margin$ncon)
			pos1 <- perm.ncon$pos1
			res.nlink[[i]] <- linknum.list.csum(ags, fgs = fgs.list, 
					netlist = pos1, gnum = TRUE, gsym = genes)
			##
			pnetout[[i]] <-   pos1     
			
		}
		if (doperm == "no" && stat == "M") {
			res.nlink[[i]] <- linknum.list.csum(ags, fgs = fgs.list, 
					netlist = pnet[[i]], gnum = TRUE, gsym = genes)
			##
		}
	}
	
	if (doperm == "no") pnetout <- pnet   
		
	if (stat == "F") {

		stac.nlink <- cbind(res.nlink,nlink)
		rownames(stac.nlink) <- names(fgs.list)
		meanlink <- apply(stac.nlink, 1, mean)
		se <- apply(stac.nlink, 1, sd)
		se <- ifelse(se == 0, 1, se)
		stac.zscore <- (stac.nlink - meanlink )/se
		zscore <- stac.zscore[,ncol(stac.nlink)]
		pvalue<-rep(0,nrow(stac.nlink))
		for (i in 1:nrow(stac.nlink)){
			allperm<-stac.nlink[i,]; nallperm<-length(allperm)  
			pvalue[i] <- min(2*min(sum(nlink[i]<=allperm)/nallperm,sum(nlink[i]>=allperm)/nallperm),1)
		}
		##
		FDR <- pval2FDR(pvalue)
		#MainResult <- data.frame(Number_links= nlink,  Expected_links = meanlink , Number_of_Genes=ngenefgs,
		#Number_of_AGS_genes=numgene, Z_score=zscore, P_value=pvalue,  FDR= FDR)
		
		#return(list( MainResult= MainResult   ,geneinfgs=geneinfgs, fgs.list =fgs.list, pnetout = pnetout)).
		res <- list(nlink = nlink, res.nlink = res.nlink, zscore = zscore, pvalue = pvalue, FDR =FDR,
						ngenefgs =ngenefgs ,numgene= numgene, geneinfgs=geneinfgs, fgs.list =fgs.list, exp.link=meanlink , pnetout = pnetout)


	}
	if (stat == "M") {
		BSTAR <- array(0, dim = c(nrow(nlink), ncol(nlink), nperm + 1))
		for (i in 1:nperm) {
			BSTAR[, , i] <- res.nlink[[i]]
		}
		BSTAR[, , nperm + 1] <- nlink

		StatRes <- zstat(BSTAR)
		zscore.mat <- StatRes$Z
		meanlink  <- StatRes $meanlink
		zscore= zscore.mat[,ncol(zscore.mat)]	
		max.nlink = apply(nlink,1,max)

		pvalue <-rep(0,nrow(zscore.mat))
		for (i in 1:nrow(zscore.mat)){
			allz<-zscore.mat[i,]; nallz<-length(allz) 
			if (!is.nan(zscore.mat[i,nallz])) {pvalue[i]<- min(2*min(sum(zscore.mat[i,nallz]<=allz)/nallz, sum(zscore.mat[i,nallz]>=allz)/nallz),1)}
			if (is.nan(zscore.mat[i,nallz])) {pvalue[i]<-1}
		}
		FDR <- pval2FDR(pvalue)
		#MainResult <- data.frame(Number_links= nlink,  Expected_links = meanlink , Number_of_Genes=ngenefgs,
		#Number_of_AGS_genes=numgene, Z_score=zscore, P_value=pvalue,  FDR= FDR)
		#whichmax.nlink = apply(nlink,1,function(x) ifelse( sum(x) >0, which.max( x), 0  ) )							
						
		res <- list(nlink= max.nlink, Matnlink = nlink,  res.nlink = res.nlink, zscore= zscore, zscore.mat = zscore.mat, 
				pvalue = pvalue, FDR =FDR,	ngenefgs =ngenefgs ,numgene= numgene, geneinfgs=geneinfgs, fgs.list =fgs.list, exp.link=meanlink , pnetout = pnetout)
	

		#return(list(MainResult=MainResult  , geneinfgs=geneinfgs, fgs.list =fgs.list, pnetout = pnetout))
	}

	if (	length(res$nlink) <1 ) 	print("No result, please check your inputs!!!")
						

	else {
	  if (!is.list(FGS)) {
		if (FGS == "KEGG" | fgslib=="KEGG.db")  { 
			getcode <- function (y) {
				ff <- substr(y,1,3)
				if( is.na(as.numeric(ff) )== T )  code <- substr(y,4,nchar(y) )
				else  code <- y   
				}	
				
				PathID <- names(res$nlink)
				if (stat=="F") combres <- data.frame(Number_links= res$nlink,  Expected_links = res$exp.link, 
					Number_of_Genes=res$ngenefgs ,Number_of_AGS_genes=res$numgene, Z_score=res$zscore, P_value=res$pvalue,  FDR= res$FDR)

				else  combres <- data.frame(Max_number_links= res$nlink, Expected_links = res$exp.link, 
					Number_of_Genes=res$ngenefgs ,Number_of_AGS_genes=res$numgene, Z_score=res$zscore, P_value=res$pvalue,  FDR= res$FDR)

				options(warn=-1)
				PathID1 <- sapply(PathID , function (x) getcode(x)  )
				options(warn=1)
				combres <-   data.frame(PATH_ID = PathID1, combres, PathID  )
				pathId <- AnnotationDbi::as.list(KEGGPATHID2NAME)
				KEGGPath <- data.frame(PATH_ID=names(pathId ),PATH_NAME= unlist(pathId ))
				pathIDres <- data.frame(KEGGPath[which(KEGGPath[,1]  %in% PathID1 ),])
				finalres <- merge(pathIDres ,combres )
				finalres[,1]  <- finalres [,ncol(finalres)]
				ResultNEAxls <- finalres[,-ncol(finalres)]
				

			if (stat=="M"){
				### get KEGG PathID for stat= 'M' , Produce a matrix of statatistic ##
				nlink.M <-   data.frame(PATH_ID = PathID1, PathID  ,res$Matnlink )
				nlink.M <- merge(pathIDres ,nlink.M)
				nlink.M <- nlink.M[,-1]
				Z.score <- data.frame(PATH_ID = PathID1,PathID  , res$zscore.mat)
				Z.score  <- merge(pathIDres ,Z.score )
				Z.score <- Z.score[,-1]

	
				}
							
			}
						
			if (FGS %in% c("CC","MF","BP") | fgslib=="GO.db") {
				GoTerm <- function (x) { 
					term1 <- GOTERM[[x]]
					GoInput <- cbind ( GOID= GOID(term1 ) ,  TERM= Term(term1 ), Definition= Definition(term1 ),
						Ontology= Ontology(term1 ))
					return(GoInput )
					}
				#if (stat=="F") {
				goID <-names(res[[1]])
				resGO <- t(sapply(goID ,GoTerm ))
				colnames(resGO) <- c("GOID", "Term", "Definition", "Ontology")
				
				if (stat=="F") ResultNEAxls <- data.frame(resGO ,Number_links= res$nlink, Expected_links = res$exp.link,
							Number_of_Genes=res$ngenefgs ,Number_of_AGS_genes=res$numgene, Z_score=res$zscore, P_value=res$pvalue,  FDR= res$FDR)

				else  ResultNEAxls <- data.frame(resGO ,Max_number_links= res$nlink,  Expected_links = res$exp.link, 
					Number_of_Genes=res$ngenefgs ,Number_of_AGS_genes=res$numgene, Z_score=res$zscore, P_value=res$pvalue,  FDR= res$FDR)

				#}
							
				if (stat=="M"){
				   	## get GO PathID for stat= 'M' ##
					#goID <- rownames(res$Matnlink)
					#resGO <- t(sapply(goID ,GoTerm ))
					#colnames(resGO) <- c("GOID", "Term", "Definition", "Ontology")
					nlink.M <- data.frame(resGO ,res$Matnlink)
					Z.score <- data.frame(resGO , res$zscore.mat)
					}
			}
						
			if (FGS == "reactome" | fgslib=="reactome.db") {
				#if (stat=="F") {
				pathres <- names(res$nlink)
				pathId <- AnnotationDbi::as.list(reactomePATHID2NAME)
				pathIdres <- pathId [as.character(pathres) ]
				x <- lapply(pathIdres , FUN="[", 1)
				y <- lapply(x, FUN=unlist)
				ReactomePath <- data.frame(PATH_ID=names(y ),PATH_Desc= unlist(y))
				
				if (stat=="F") ResultNEAxls <- data.frame(ReactomePath , Number_links= res$nlink,  Expected_links = res$exp.link, 
						Number_of_Genes=res$ngenefgs ,Number_of_AGS_genes=res$numgene, Z_score=res$zscore, P_value=res$pvalue,  FDR= res$FDR)


				else ResultNEAxls <- data.frame(ReactomePath ,Max_number_links= res$nlink,  Expected_links = res$exp.link, 
					Number_of_Genes=res$ngenefgs ,Number_of_AGS_genes=res$numgene, Z_score=res$zscore, P_value=res$pvalue,  FDR= res$FDR)

				#}
				if (stat=="M"){
					### get Reactome PathID for stat= 'M' ##
					#pathres <- rownames(res$Matnlink)
					#pathId <- AnnotationDbi::as.list(reactomePATHID2NAME)
					#pathIdres <- pathId [as.character(pathres) ]
					#x <- lapply(pathIdres , FUN="[", 1)
					#y <- lapply(x, FUN=unlist)
					#ReactomePath <- data.frame(PATH_ID=names(y ),PATH_Desc= unlist(y))
					nlink.M <- data.frame(ReactomePath ,res$Matnlink)
					Z.score <- data.frame(ReactomePath , res$zscore.mat)
					}
			}
                
			if (!FGS %in% c("KEGG", "CC","MF","BP", "reactome") | !fgslib %in% c("KEGG.db", "GO.db", "reactome.db") ) {
				if (stat=="F") ResultNEAxls <- data.frame(PATH_ID=  names(res$nlink),Number_links= res$nlink, Expected_links = res$exp.link,
						Number_of_Genes=res$ngenefgs ,Number_of_AGS_genes=res$numgene, Z_score=res$zscore, P_value=res$pvalue,  FDR= res$FDR)
				
				else {
					ResultNEAxls <- data.frame(PATH_ID=  names(res$nlink),Max_number_links= res$nlink,  Expected_links = res$exp.link, 
					Number_of_Genes=res$ngenefgs ,Number_of_AGS_genes=res$numgene, Z_score=res$zscore, P_value=res$pvalue,  FDR= res$FDR)
					nlink.M = res$Matnlink
					Z.score = res$zscore.mat
					}
				}
			
			  }
		 else {
			if (stat=="F") ResultNEAxls <- data.frame(PATH_ID=  names(res$nlink),Number_links= res$nlink, Expected_links = res$exp.link,
					Number_of_Genes=res$ngenefgs ,Number_of_AGS_genes=res$numgene, Z_score=res$zscore, P_value=res$pvalue,  FDR= res$FDR)

			else {
					ResultNEAxls <- data.frame(PATH_ID=  names(res$nlink),Max_number_links= res$nlink,  Expected_links = res$exp.link, 
					Number_of_Genes=res$ngenefgs ,Number_of_AGS_genes=res$numgene, Z_score=res$zscore, P_value=res$pvalue,  FDR= res$FDR)
					nlink.M = res$Matnlink
					Z.score = res$zscore.mat
					}


			}
	ResultNEAxls <- ResultNEAxls [order(ResultNEAxls$FDR ),]
						
	if (stat=="F") 	return(list(MainResult=ResultNEAxls , geneinfgs=geneinfgs, fgs.list =fgs.list, pnetout = pnetout))
		
   	else return(list(MainResult=ResultNEAxls, nlink.M =nlink.M,zscore.mat=Z.score,geneinfgs=geneinfgs, fgs.list =fgs.list, pnetout = pnetout ))
     


	}
}


